﻿using System.Data;
using Oracle.ManagedDataAccess.Client;

var conn = new OracleConnection();

var ocsb = new OracleConnectionStringBuilder
{
    DataSource = "localhost:1521/ACA",
    UserID = "TESTACA",
    Password = "pswd",
    Pooling = false,
    //SelfTuning = false,
    //StatementCachePurge = true
};

conn.ConnectionString = ocsb.ConnectionString;
conn.Open();
Console.WriteLine($"Connection established ({conn.ServerVersion})");

// For testing purpose
var delete = conn.CreateCommand();
delete.CommandText = "ALTER TABLE MODELESIMPLE DROP COLUMN Test";
//delete.AddToStatementCache = false;
delete.ExecuteReader();

var select = conn.CreateCommand();
//select.AddToStatementCache = false;
select.CommandText = "SELECT * FROM MODELESIMPLE";

FillSchema(select);

var cmd = conn.CreateCommand();
cmd.CommandText = "ALTER TABLE MODELESIMPLE ADD Test INTEGER";
//cmd.AddToStatementCache = false;
cmd.ExecuteReader();

// Throw exception
FillSchema(select);

Console.ReadKey();


void FillSchema(OracleCommand selectCommand)
{
    using var adapter = new OracleDataAdapter();
    adapter.SelectCommand = selectCommand;
    adapter.MissingSchemaAction = MissingSchemaAction.AddWithKey;

    using var schemaTable = new DataTable();
    adapter.FillSchema(schemaTable, SchemaType.Source);
}